# Copyright (c) 2011 Red Hat, Inc.
#
# This file is part of CloudFS.
#
# CloudFS is free software: you can redistribute it and/or modify it under the
# terms of the GNU Affero General Public License as published by the Free
# Software Foundation, either version 3 of the License, or (at your option)
# any later version.
#
# CloudFS is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
#
# You should have received a copy of the GNU Affero General Public License *
# along with CloudFS.  If not, see <http://www.gnu.org/licenses/>.

import glob
import json
import os
import re

import volfilter
import cfs_paths

def vol_map (vol_name):
	vol_dir = "%s/%s" % (cfs_paths.info_dir, vol_name)
	vol_re = re.compile(vol_dir+"/")
	map = {}
	for link in glob.iglob("%s/*" % cfs_paths.used_subdir):
		real_file = os.readlink(link)
		m = vol_re.match(real_file)
		if not m:
			continue
		graph, last = volfilter.load(real_file)
		for xl in graph.itervalues():
			if xl.type == "storage/posix":
				path = os.path.dirname(xl.opts["directory"])
				port = os.path.basename(link)
				map[path] = port
				break
	return json.dumps(map)

